<template>
  <div class="w-100 h-100">
    <slot v-if="ready">
      <leaflet-pane name="basemap" :zindex="190">
        <leaflet-tile-layer :url="defaultBasemap"></leaflet-tile-layer>
      </leaflet-pane>
      <leaflet-pane v-for="pane in panes" :key="createUniqueId(pane)" :name="pane.name" :zindex="pane.zindex">
        <leaflet-wms-layer v-for="layer in layersInPane(pane)" :key="createUniqueId(layer)"
          :identifier="layer.id">
        </leaflet-wms-layer>
      </leaflet-pane>
      <leaflet-pane name="borders" :zindex="300">
        <leaflet-wms-simple-layer
          url="http://mapservices.ipma.pt/common/boundaries/wms"
          name="coastlines">
        </leaflet-wms-simple-layer>
      </leaflet-pane>
      <leaflet-marker v-for="location in locations" :key="createUniqueId(location)"
        :identifier="location.id">
      </leaflet-marker>
      <leaflet-control>
        <pressure-level-control/>
      </leaflet-control>
    </slot>
  </div>
</template>

<script>
// Mixins
import LeafletMixin from '@/dashboard/mixins/Leaflet'

// Components
import LeafletPane from './LeafletPane'
import LeafletTileLayer from './LeafletTileLayer'
import LeafletWmsLayer from './LeafletWmsLayer'
import LeafletWmsSimpleLayer from './LeafletWmsSimpleLayer'
import LeafletMarker from './LeafletMarker'
import LeafletControl from './LeafletControl'
import PressureLevelControl from './PressureLevelControl'

import { createUniqueId } from '@/core/util'

export default {
  name: 'leafletmap',

  // Mixins used by the LeafletMap component
  mixins: [
    LeafletMixin,
  ],

  data() {
    return {
      ready: false,
    }
  },

  // Computed properties from the Vuex store
  computed: {
    workspace: {
      get() {
        return this.$parent.workspace
      }
    },

    defaultBasemap: {
      get() {
        return this.$store.state.defaultBasemap
      }
    },

    layers: {
      get() {
        return this.$store.state.workspaces[this.workspace].layers
      },
    },

    locations: {
      get() {
        return this.$store.state[this.workspace].locations
      },
    },
    
    panes: {
      get() {
        return this.$store.state.panes
      },
    },

    workspaceCount: {
      get() {
        return this.$store.state.workspaces.length
      },
    },

    currentPanel: {
      get() {
        return this.$store.state.workspaces[this.workspace].ui.currentPanel
      },
    },
  },

  methods: {
    setReady() {
      this.ready = true
    },

    layersInPane(pane) {
      return this.layers.filter((layer) => {
        return this.$store.getters.getLayerById(layer.id).pane === pane.id
      })
    },

    createUniqueId() {
      return createUniqueId()
    },
  },

  watch: {
    workspaceCount() {
      this.mapObject.invalidateSize(true)
    },

    currentPanel() {
      this.mapObject.invalidateSize(false)
    },
  },

  mounted() {
    //this.createBasemap(this.defaultBasemap, {})
    this.setReady()
  },

  components: {
    LeafletPane,
    LeafletTileLayer,
    LeafletWmsLayer,
    LeafletWmsSimpleLayer,
    LeafletMarker,
    LeafletControl,
    PressureLevelControl,
  },
}
</script>
